<script setup lang="ts">
import type { Stock } from '@/types/Stock';
import { inject, ref, type Ref } from 'vue';
import {useStockStore} from "@/stores/stock"
import type { VForm } from 'vuetify/components';


const stockStore = useStockStore()
const refform = ref<VForm | null>(null)

  const loading =ref(false)
  async function save(){
    let { valid } = await refform.value!.validate()
    if (!valid) return
    stockStore.save()
   
    
}
  
</script>
<template>
    <v-row justify="center">
    <v-dialog
      v-model="stockStore.dialogS"
      persistent
      width="1024"
    >
      <v-card>
        <v-card-title>
          <span class="text-h5">Add Stock Product</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="stockStore.formS">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
            <v-text-field

          v-model="stockStore.editedSProduct.name"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required']"
          class="mb-2"
          clearable
          label="Product Name"
        ></v-text-field>
            </v-col>
          <v-col cols="12" sm="12" md="6">
            <v-text-field
          v-model="stockStore.editedSProduct.minimum"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required',(v) => v>0||'Minimum is Lower',
    (v) => /^\d+$/.test(v) || 'Please enter a valid number']"
          class="mb-2"
          clearable
          label="Minimum"
        ></v-text-field>
          </v-col >
        
          <v-col cols="12" sm="12" md="6">
            <v-text-field
          v-model="stockStore.editedSProduct.price"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required',(v) => v>0||'Price is lower',
    (v) => /^\d+$/.test(v) || 'Please enter a valid number']"
          class="mb-2"
          clearable
          label="Price"
        ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6">
         <v-text-field
          v-model="stockStore.editedSProduct.unit"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required',(v) => !/\d/.test(v) || 'Field cannot contain numbers']"
          class="mb-2"
          clearable
          label="Unit"
        ></v-text-field>
        </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="stockStore.dialogS = !stockStore.dialogS">
                  Close
                </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
    </v-dialog>
  </v-row>
</template>